Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.mozilla.javascript.ast
Class Comment

    java.lang.Object
      org.mozilla.javascript.Node
          org.mozilla.javascript.ast.AstNode
              org.mozilla.javascript.ast.Comment

All Implemented Interfaces:
  java.lang.Comparable<AstNode>, java.lang.Iterable<Node>

    public class Comment

extends AstNode

Node representing comments. Node type is `Token.COMMENT`.

JavaScript effectively has five comment types:

1. // line comments
2. /* block comments *\/
3. /** jsdoc comments *\/
4. <!-- html-open line comments
5. ^\\s*--> html-close line comments

The first three should be familiar to Java programmers. JsDoc comments are really just block comments with some conventions about the formatting within the comment delimiters. Line and block comments are described in the Ecma-262 specification.

SpiderMonkey and Rhino also support HTML comment syntax, but somewhat counterintuitively, the syntax does not produce a block comment. Instead, everything from the string <!-- through the end of the line is considered a comment, and if the token --> is the first non-whitespace on the line, then the line is considered a line comment. This is to support parsing JavaScript in <script> HTML tags that has been "hidden" from very old browsers by surrounding it with HTML comment delimiters.

Note the node start position for Comment nodes is still relative to the parent, but Comments are always stored directly in the AstRoot node, so they are also effectively absolute offsets.

Nested Class Summary

Nested classes/interfaces inherited from class org.mozilla.javascript.ast.AstNode
`AstNode.DebugPrintVisitor, AstNode.PositionComparator`

Nested classes/interfaces inherited from class org.mozilla.javascript.Node
`Node.NodeIterator`

Field Summary

Fields inherited from class org.mozilla.javascript.ast.AstNode
`length, parent, position`

Fields inherited from class org.mozilla.javascript.Node
`ATTRIBUTE_FLAG, BOTH, CASEARRAY_PROP, CATCH_SCOPE_PROP, CONTROL_BLOCK_PROP, DECR_FLAG, DESCENDANTS_FLAG, DESTRUCTURING_ARRAY_LENGTH, DESTRUCTURING_NAMES, DESTRUCTURING_PARAMS, DESTRUCTURING_SHORTHAND, DIRECTCALL_PROP, END_DROPS_OFF, END_RETURNS, END_RETURNS_VALUE, END_UNREACHED, END_YIELDS, EXPRESSION_CLOSURE_PROP, first, FUNCTION_PROP, GENERATOR_END_PROP, INCRDECR_PROP, ISNUMBER_PROP, JSDOC_PROP, LABEL_ID_PROP, last, LAST_PROP, LEFT, lineno, LOCAL_BLOCK_PROP, LOCAL_PROP, MEMBER_TYPE_PROP, NAME_PROP, next, NON_SPECIALCALL, OBJECT_IDS_PROP, PARENTHESIZED_PROP, POST_FLAG, PROPERTY_FLAG, propListHead, REGEXP_PROP, RIGHT, SKIP_INDEXES_PROP, SPECIALCALL_EVAL, SPECIALCALL_PROP, SPECIALCALL_WITH, TARGETBLOCK_PROP, type, VARIABLE_PROP`

Constructor Summary
`Comment(int pos, int len, Token.CommentType type, java.lang.String value)` Constructs a new Comment

Method Summary
`Token.CommentType` | `getCommentType()` Returns the comment style
`java.lang.String` | `getValue()` Returns a string of the comment value.
`void` | `setCommentType(Token.CommentType type)` Sets the comment style
`java.lang.String` | `toSource(int depth)` Emits source code for this node.
`void` | `visit(NodeVisitor v)` Comment nodes are not visited during normal visitor traversals, but comply with the `AstNode.visit(org.mozilla.javascript.ast.NodeVisitor)` interface.

Methods inherited from class org.mozilla.javascript.ast.AstNode
`addChild, assertNotNull, codeBug, compareTo, debugPrint, depth, getAbsolutePosition, getAstRoot, getEnclosingFunction, getEnclosingScope, getLength, getLineno, getParent, getPosition, hasSideEffects, makeIndent, operatorToString, printList, setBounds, setLength, setParent, setPosition, setRelative, shortName, toSource`

Methods inherited from class org.mozilla.javascript.Node
`addChildAfter, addChildBefore, addChildrenToBack, addChildrenToFront, addChildToBack, addChildToFront, getChildBefore, getDouble, getExistingIntProp, getFirstChild, getIntProp, getJsDoc, getLastChild, getLastSibling, getNext, getProp, getScope, getString, getType, hasChildren, hasConsistentReturnUsage, iterator, labelId, labelId, newNumber, newString, newString, newTarget, putIntProp, putProp, removeChild, removeChildren, removeProp, replaceChild, replaceChildAfter, setDouble, setJsDoc, setLineno, setScope, setString, setType, toString, toStringTree`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Comment

    public Comment(int pos,
                   int len,
                   Token.CommentType type,
                   java.lang.String value)

  Constructs a new Comment

  Parameters:
    `pos` - the start position
    `len` - the length including delimiter(s)
    `type` - the comment type
    `value` - the value of the comment, as a string

Method Detail

### getCommentType

    public Token.CommentType getCommentType()

  Returns the comment style

### setCommentType

    public void setCommentType(Token.CommentType type)

  Sets the comment style

  Parameters:
    `type` - the comment style, a `Token.CommentType`

### getValue

    public java.lang.String getValue()

  Returns a string of the comment value.

### toSource

    public java.lang.String toSource(int depth)

  Description copied from class: `AstNode`
  Emits source code for this node. Callee is responsible for calling this function recursively on children, incrementing indent as appropriate.

  Note: if the parser was in error-recovery mode, some AST nodes may have `null` children that are expected to be non-`null` when no errors are present. In this situation, the behavior of the `toSource` method is undefined: `toSource` implementations may assume that the AST node is error-free, since it is intended to be invoked only at runtime after a successful parse.

  Specified by:
    `toSource` in class `AstNode`
  Parameters:
    `depth` - the current recursion depth, typically beginning at 0 when called on the root node.

### visit

    public void visit(NodeVisitor v)

  Comment nodes are not visited during normal visitor traversals, but comply with the `AstNode.visit(org.mozilla.javascript.ast.NodeVisitor)` interface.

  Specified by:
    `visit` in class `AstNode`
  Parameters:
    `v` - the object to call with this node and its children

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD